﻿
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Threading.Tasks;
using Wisej.Web;

namespace WisejAsync
{
	public partial class Window1 : Form
	{
		List<MyData> _myData = new List<MyData>();
		public Window1()
		{
			InitializeComponent();
		}

		private void Window1_Load(object sender, EventArgs e)
		{

		}

		private async Task FillDataSource()
		{
			_myData.Clear();

			this.progressBar1.Text = "Fetching Data From DataBase";
			this.dataGridView1.ShowLoader = true;
			for (int i = 0; i < 1000; i++)
			{
				_myData.Add(new MyData()
				{
					Name = "Name " + i.ToString(),
					Address = "Address " + i.ToString(),
					Phone = "Phone " + i.ToString()
				});

				if (i % 100 == 0)
				{
					await Task.Delay(150);
					this.progressBar1.PerformStep();
					Application.Update(this.dataGridView1);
				}

			}

			dataGridView1.DataSource = _myData;
			this.dataGridView1.ShowLoader = false;
			this.progressBar1.Text = "Done!!";
			this.progressBar1.BarColor = Color.Green;
			Application.Update(this.dataGridView1);
		}

		public class MyData
		{
			public string Name { get; set; }
			public string Address { get; set; }
			public string Phone { get; set; }
		}

		private async void button1_Click(object sender, EventArgs e)
		{
			await FillDataSource();
		}
	}
}
